#ifndef DYNA_EXTVIEW_MODULE_H
#define DYNA_EXTVIEW_MODULE_H

#define EXTVIEWMOD_STR	"DynaExtViewModule"
#define EXTVIEWMOD_VER	2

// Load Progress callback function definition
typedef int (CALLBACK *LOADPROGRESS)( int nCurrent, int nTotal, LONG_PTR lData );

typedef struct {
	LPCSTR magicStr;	// ʕւ̃|C^iEXTVIEWMOD_STRݒ肷j
	DWORD version;		// \̂̃o[WiEXTVIEWMOD_VERݒ肷j
	DWORD flags;		// W[̓tO
	DWORD reserved;		// \
	LPCSTR moduleshortname;	// ZW[
	LPCSTR defaultfilter;	// ̓t@C̃ftHgtB^i'|'ŋ؂ĕwj
	LPCWSTR modulefullname;	// W[
	LPCWSTR copyrights;		// Rs[Cg
	HANDLE (WINAPI *Create)( DWORD dwFlags );
	void (WINAPI *Release)( HANDLE hExView );
	int (WINAPI *Load)( HANDLE hExView, LPCWSTR pFileName, const BYTE* pBuffer, size_t dwBufferSize, BOOL* pKeepBuffer, HDC hDC, HWND hWndLoading, LOADPROGRESS ProgProc, LONG_PTR lProgData );
	int (WINAPI *SetViewWindow)( HANDLE hExView, HWND hWnd );
	int (WINAPI *Show)( HANDLE hExView, HDC hDC, const LPRECT rcSrc, const LPRECT rcDst, bool bUseHalfToneMode );
	int (WINAPI *MessageProc)( HANDLE hExView, UINT msg, WPARAM wParam, LPARAM lParam );
} ExtViewModule;


/// Module attribute flags
#define EXTVIEW_ATTR_NONE			0x00000000
#define EXTVIEW_ATTR_NOMEMORYSUPPORT	0x00000001

/// extview function result codes
#define EXTVIEW_RESULT_ERROR		-1
#define EXTVIEW_RESULT_OK			0
#define EXTVIEW_RESULT_NOT_IMPL		1
#define EXTVIEW_RESULT_DISCARD		2

/// Command Message
// RFU = Reserved for Future Use. RFÛ̂ dyna{̂ł͎gpĂ܂B
#define EXVIEW_MSG_CONFIG_DIALOG	(WM_USER +  0)	//RFU
#define EXVIEW_MSG_GET_STATE		(WM_USER +  1)	//RFU	wParam:int*
#define EXVIEW_MSG_PLAY				(WM_USER +  2)
#define EXVIEW_MSG_STOP				(WM_USER +  3)	//RFU
#define EXVIEW_MSG_PAUSE			(WM_USER +  4)	//RFU
#define EXVIEW_MSG_GET_NATIVESIZE	(WM_USER +  5)	// wParam:SIZE*
#define EXVIEW_MSG_GET_VIEWSIZE		(WM_USER +  6)	// wParam:SIZE*
#define EXVIEW_MSG_GET_DEPTH		(WM_USER +  7)	// wParam:int*
#define EXVIEW_MSG_GET_DURATION		(WM_USER +  8)	// wParam:long*
#define EXVIEW_MSG_GET_CURRENTPOS	(WM_USER +  9)	// wParam:long*
#define EXVIEW_MSG_SEEK_OFS			(WM_USER + 10)	//RFU	wParam:long*
#define EXVIEW_MSG_SEEK_ABS			(WM_USER + 11)	//RFU	wParam:long*
#define EXVIEW_MSG_FRAMESTEP		(WM_USER + 12)	//RFU
#define EXVIEW_MSG_VOLUME_GET		(WM_USER + 13)	//RFU	wParam:long*
#define EXVIEW_MSG_VOLUME_SET		(WM_USER + 14)	//RFU	wParam:long
#define EXVIEW_MSG_ROTATE_VIEW		(WM_USER + 15)	// wParam:int
#define EXVIEW_MSG_HIDE_CURSOR		(WM_USER + 16)	// wParam:int
#define EXVIEW_MSG_SET_BGCOLOR		(WM_USER + 17)	// wParam:COLORREF
#define EXVIEW_MSG_ADJUSTVIEWRECT	(WM_USER + 18)	// wParam:RECT*

#define EXVIEW_MSG_CALLBACK			(WM_USER + 98)	//RFU	wParam, lParam
#define EXVIEW_MSG_NOTIFY			(WM_USER + 99)	// wParam, lParam

/// EXVIEW_MSG_GET_STATE result
#define EXVIEW_STATE_STOP			0	//RFU
#define EXVIEW_STATE_PAUSE			1	//RFU
#define EXVIEW_STATE_PLAY			2	//RFU

/// EXVIEW_MSG_NOTIFY message code (wParam)
#define EXVIEW_NC_COMPLETE			1	//RFU
#define EXVIEW_NC_STARTED			2	//RFU
#define EXVIEW_NC_PAUSED			3	//RFU
#define EXVIEW_NC_SIZE_CHANGED		4
#define EXVIEW_NC_LENGTH_CHANGED	5


#endif//DYNA_EXTVIEW_MODULE_H